<?php

namespace OXModule\StructClass;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for moveContextDatabase StructClass
 * @subpackage Structs
 */
class MoveContextDatabase extends AbstractStructBase
{
    /**
     * The ctx
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \OXModule\StructClass\Context
     */
    public $ctx;
    /**
     * The dst_database_id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \OXModule\StructClass\Database
     */
    public $dst_database_id;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \OXModule\StructClass\Credentials
     */
    public $auth;
    /**
     * Constructor method for moveContextDatabase
     * @uses MoveContextDatabase::setCtx()
     * @uses MoveContextDatabase::setDst_database_id()
     * @uses MoveContextDatabase::setAuth()
     * @param \OXModule\StructClass\Context $ctx
     * @param \OXModule\StructClass\Database $dst_database_id
     * @param \OXModule\StructClass\Credentials $auth
     */
    public function __construct(\OXModule\StructClass\Context $ctx = null, \OXModule\StructClass\Database $dst_database_id = null, \OXModule\StructClass\Credentials $auth = null)
    {
        $this
            ->setCtx($ctx)
            ->setDst_database_id($dst_database_id)
            ->setAuth($auth);
    }
    /**
     * Get ctx value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \OXModule\StructClass\Context|null
     */
    public function getCtx()
    {
        return isset($this->ctx) ? $this->ctx : null;
    }
    /**
     * Set ctx value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \OXModule\StructClass\Context $ctx
     * @return \OXModule\StructClass\MoveContextDatabase
     */
    public function setCtx(\OXModule\StructClass\Context $ctx = null)
    {
        if (is_null($ctx) || (is_array($ctx) && empty($ctx))) {
            unset($this->ctx);
        } else {
            $this->ctx = $ctx;
        }
        return $this;
    }
    /**
     * Get dst_database_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \OXModule\StructClass\Database|null
     */
    public function getDst_database_id()
    {
        return isset($this->dst_database_id) ? $this->dst_database_id : null;
    }
    /**
     * Set dst_database_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \OXModule\StructClass\Database $dst_database_id
     * @return \OXModule\StructClass\MoveContextDatabase
     */
    public function setDst_database_id(\OXModule\StructClass\Database $dst_database_id = null)
    {
        if (is_null($dst_database_id) || (is_array($dst_database_id) && empty($dst_database_id))) {
            unset($this->dst_database_id);
        } else {
            $this->dst_database_id = $dst_database_id;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \OXModule\StructClass\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \OXModule\StructClass\Credentials $auth
     * @return \OXModule\StructClass\MoveContextDatabase
     */
    public function setAuth(\OXModule\StructClass\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \OXModule\StructClass\MoveContextDatabase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
